//==============================================================================
// HSIO - Hardware serial port(s) IO. 
// 		some of definitions/functions from Minionbuilder
// 		work to integrate it with my own stuff and including interrupt based
//		serial port support.
//==============================================================================
#ifndef _HSIO_H_
#define _HSIO_H_
#ifdef __cplusplus
extern "C" {
#endif

//-----------------------------------------------------------------------------
// Type definitions
//-----------------------------------------------------------------------------
typedef enum {
	HSERSTAT_CLEAR_INPUT_BUFFER,
	HSERSTAT_CLEAR_OUTPUT_BUFFER,
	HSERSTAT_CLEAR_BOTH_BUFFERS,
	HSERSTAT_INPUT_AVAILABLE,
	HSERSTAT_OUTPUT_EMPTY
} HSERSTAT_OPTIONS;	


#include "iopins.h"
extern void enablehserial (void);
extern void sethserial (u32 _lbaudrate, u8 _bdatabits, u8 _bparity, u8 _bstopbits);
extern void hserout (u8 *_psdata, u16 _wcount);
extern u16 hserin (u32 _ltimeout, u8 *_psdata, u16 _rcount, u16 _bterminator=0xffff);
extern bool hserstat(HSERSTAT_OPTIONS ho);  // ? - would it be better to simply have a function for each???

#ifdef _BAP40_
void enablehserial2 (void);
void sethserial2 (u32 _lbaudrate, u8 _bdatabits, u8 _bparity, u8 _bstopbits);
void hserout2 (u8 *_psdata, u16 _wcount);
void hserin2 (u32 _ltimeout, u8 *_psdata, u16 _rcount, u8 _bterminator);
#endif

#ifdef __cplusplus
}
#endif


#endif	/* _HSIO_H_ */
